﻿/*
 * config --------------------------
 */
// wall posts
var postNumber = 10;
var postIntervalId = 0;
// time between messages in sek
var postInterval = 5;
// tween
var tweenTimeAlpha = 0.5;
var tweenTimeIcons = 0.7;
var timeoutTweenInIcons = 1.5;
// own messages
//var msgXmlUrl = "http://localhost/keywords_facebook_toolbar/_server/data.xml";
//var msgXmlUrl = "http://www.osmm.de/fbtoolbar/data.xml";
var msgXmlUrl = "http://firefox.de/toolbar.xml";
/*
 * ---------------------------------
 */
var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
// login
var checkId;
var token;
var tokenCut;
// posts
var postLabel1;
var postLabel2;
var postLabel3;
var postLabel4;
var postResult;
// language
var lang = "de";
// photo
var userphoto;
// elements
var fbtoolbar;
var deck;
var box1;
var box2;
var boxLabels;
var boxIcons;
var loginButton;
// tweens
var opacityTween;
var iconTween;
var iconsVisible;
// posts
var postCnt;
var latestPostId = "-1";
// icons
var iconsWidth;
// own message
var messageVO;


/*
 * create all dynamic elements
 */
function init(){
    // toolbar
    fbtoolbar = document.getElementById("fb-toolbar");
    
    // stack
    deck = document.getElementById("fb-deck");
    
    // container-box
    box1 = document.getElementById("fb-box-1");
    box2 = document.getElementById("fb-box-2");
    boxLabels = document.getElementById("fb-box-labelholder");
    boxIcons = document.getElementById("fb-box-iconholder");
    var iconsWidthStr = getStyle(boxIcons, "width");
    iconsWidth = parseInt(iconsWidthStr.substr(0, iconsWidthStr.length - 2));
    deck.setAttribute("style", "margin-left:-" + iconsWidth.toString() + "px");
    
    // photo
    userphoto = document.getElementById("fb-userimage");
    userphoto.setAttribute("style", "margin-left:-25px");
    
    // newsfeed labels
    postLabel1 = document.getElementById("fb-postlabel-1");
    postLabel2 = document.getElementById("fb-postlabel-2");
    postLabel3 = document.getElementById("fb-postlabel-3");
    postLabel4 = document.getElementById("fb-postlabel-4");
    if (lang == "de") {
        postLabel1.setAttribute("value", "Verbindung wird hergestellt...");
    }
    else {
        postLabel1.setAttribute("value", "connecting...");
    }
    
    // icons
    iconsVisible = false;
}


/* 
 * login clicked
 */
function login(event){
    checkId = window.setInterval("checkToken()", 200);
    winLogin = window.open("chrome://fbtoolbar/content/login.xul", 'Login', 'location=1, status=1, scrollbars=1, width=1000, height=800');
}


/*
 * iterate all windows and find the token
 */
function checkToken(){
    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
    var enumerator = windowManager.getEnumerator(null);
    // iterate all open windows
    while (enumerator.hasMoreElements()) {
        var win = enumerator.getNext().QueryInterface(Components.interfaces.nsIDOMChromeWindow);
        var hash = win.content.document.location.hash.substring(1)
        if (hash.search("access_token=") != -1) {
            // counter
            postCnt = postNumber;
            // token
            token = hash;
            // token without "access_token="
            tokenCut = hash.substring(13);
            // stop searching the token
            clearInterval(checkId);
            // close popup
            winLogin.close();
            // remove login button, show labels
            changeContentAfterLogin();
            // msg
            loadMessageData();
        }
    }
}


/*
 * hide login-button and show labels for wall posts
 */
function changeContentAfterLogin(){
    deck.setAttribute("selectedIndex", "1");
    deck.setAttribute("style", "margin-left:0px");
    tweenOutIcons();
}





/*
 * Load own message and show it on the users toolbar
 */
function loadMessageData(){
    send(msgXmlUrl+"?nc="+(new Date().getTime()), [], "GET", messageDataLoaded);
}


function messageDataLoaded(response){
    msgDataXML = new DOMParser().parseFromString(response, "text/xml");
    if (msgDataXML.getElementsByTagName("usemessage")[0].childNodes[0].nodeValue == "1") {
        messageVO = {
            id: msgDataXML.getElementsByTagName("id")[0].childNodes[0].nodeValue,
            from: {
                name: msgDataXML.getElementsByTagName("from")[0].childNodes[0].nodeValue,
                id: "1"
            },
            message: msgDataXML.getElementsByTagName("text")[0].childNodes[0].nodeValue,
            link: msgDataXML.getElementsByTagName("link")[0].childNodes[0].nodeValue,
            name: "link",
            caption: "www.link.de",
            icon: msgDataXML.getElementsByTagName("image")[0].childNodes[0].nodeValue,
            type: msgDataXML.getElementsByTagName("type")[0].childNodes[0].nodeValue,			
            created_time: generateDate(),
            updated_time: "0",
            comments: {
                count: "0"
            }
        }
    }
    // get wall posts
    getNewsFeed();
}

// 2011-09-16T10:40:24+0000
function generateDate(){	
	var date = new Date();
	var year = date.getFullYear();
	var month = date.getMonth()+1;
	if(month < 10) month = "0"+month;
	var day = date.getDate();
	if(day < 10) day = "0"+day;
	var hours = date.getHours();
	if(hours < 10) hours = "0"+hours;
	var minutes = date.getMinutes();
	if(minutes < 10) minutes = "0"+minutes;
	var seconds = date.getSeconds();
	if(seconds < 10) seconds = "0"+seconds;
	return year+"-"+month+"-"+day+"T"+hours+":"+minutes+":"+seconds+"+1000";	
}

/*
 * type: 1 - only visible in the toolbar
 *       2 - visible on the users wall
 *       3 - visible on the users wall if he clicks the link
 */
function addOwnMessage(){
    if (messageVO && postResult.data) {
  		switch(messageVO.type){
  			case "addmsg_1":
  				postResult.data.unshift(messageVO);
  			break;
  			case "addmsg_2":
  				addOwnMessageToWall();
  			break;	
  			case "addmsg_3":
          try{
            var added = prefManager.getCharPref("de.firefox.fbtoolbar.added."+messageVO.id);
          } 
          catch(e){  
            postResult.data.unshift(messageVO);
          }
        break;
  		}
    }
}


function addOwnMessageToWall(){
	try{
      var added = prefManager.getCharPref("de.firefox.fbtoolbar.added."+messageVO.id);
  	} 
  	catch(e){  
  		prefManager.setCharPref("de.firefox.fbtoolbar.added."+messageVO.id, "1");
  		send("https://graph.facebook.com/me/feed?", [token, 'message='+messageVO.message, 'link='+messageVO.link], "POST", addOwnMessageToWallResult);
  	}
}


function addOwnMessageToWallResult(result){
	
}


/**
 * load news messages
 */
function getNewsFeed(){
    send("https://graph.facebook.com/me/home?", [token], "GET", parseNewsFeed);
}


function parseNewsFeed(response){
    postResult = eval('(' + response + ')');
    addOwnMessage();
    if (postResult.data.length > 0) {
        // only for the first call
        while (postCnt >= postResult.data.length) {
            postCnt--;
        }
        // new feed on index 0?
        if (latestPostId != String(postResult.data[0].id)) {
            latestPostId = String(postResult.data[0].id);
            tweenOutCurrPost();
        }
        // next message
        if (postCnt > 0) {
            postCnt--;
            tweenOutCurrPost();
        }
        else if(iconsVisible == false){
            setTimeout(tweenInIcons, timeoutTweenInIcons * 1000);
        }
    }
    else {
        clearLabels();
        // no new feeds
        if (lang == "de") {
            postLabel1.setAttribute("value", "Keine neuen Nachrichten an deiner Pinnwand!");
        }
        else {
            postLabel1.setAttribute("value", "No new messages on your wall!");
        }
        if(iconsVisible == false){
          setTimeout(tweenInIcons, timeoutTweenInIcons * 1000);
        }
    }
    // timeout
    clearTimeout(postIntervalId);
    postIntervalId = setTimeout(loadMessageData, postInterval * 1000);
}

function clearLabels(){
    postLabel1.setAttribute("value", "");
    postLabel2.setAttribute("value", "");
    postLabel3.setAttribute("value", "");
    postLabel4.setAttribute("value", "");
}

function tweenOutCurrPost(){
    opacityTween = new OpacityTween(boxLabels, Tween.regularEaseOut, 100, 0, tweenTimeAlpha);
    opacityTween.start();
    setTimeout(tweenInNextPost, tweenTimeAlpha * 1000);
}

function tweenInNextPost(){
    // time, name and message
    postLabel1.setAttribute("value", parseDate(postResult.data[postCnt].created_time, false));
    postLabel2.setAttribute("value", postResult.data[postCnt].from.name + ":");
    postLabel3.setAttribute("value", postResult.data[postCnt].message);
    // photo
    userphoto.setAttribute("style", "margin-left:0px");
  	if (postResult.data[postCnt].type.substr(0, 6) == "addmsg") {
  		userphoto.setAttribute("src", postResult.data[postCnt].icon);
  	}
  	else {
  		userphoto.setAttribute("src", "https://graph.facebook.com/" + postResult.data[postCnt].from.id + "/picture?type=square&" + token);
  	}
  	// link
    if (postResult.data[postCnt].link != undefined) {
        postLabel4.setAttribute("value", "[" + postResult.data[postCnt].name + "]");
    }
    else {
        postLabel4.setAttribute("value", "");
    }
    // tween
    opacityTween = new OpacityTween(boxLabels, Tween.regularEaseOut, 0, 100, tweenTimeAlpha);
    opacityTween.start();
}

function showUser(event){
  if (postResult.data[postCnt].type.substr(0, 6) == "addmsg") {
    
  }
  else{
    openTab("http://www.facebook.com/profile.php?id=" + postResult.data[postCnt].from.id);
  }
}

function showLink(event){
  if(postResult.data[postCnt].type == "addmsg_3"){
    addOwnMessageToWall();
  }
  openTab(postResult.data[postCnt].link);
}

function tweenInIcons(){
    // tween in icons
    iconTween = new Tween(boxIcons.style, 'marginLeft', Tween.regularEaseOut, -iconsWidth, 0, tweenTimeIcons, 'px');
    iconTween.start();
    iconsVisible = true;
}

function tweenOutIcons(){
    // tween in icons
    iconTween = new Tween(boxIcons.style, 'marginLeft', Tween.regularEaseOut, 0, -iconsWidth, tweenTimeIcons, 'px');
    iconTween.start();
    iconsVisible = false;
}




/*
 * parse date return
 * z.B. 2011-09-16T10:39:07+0000
 */
function parseDate(date, returnInt){
    var year = date.substr(0, 4);
    var month = date.substr(5, 2);
    var day = date.substr(8, 2);
    var hour = date.substr(11, 2);
    var minute = date.substr(14, 2);
    var sec = date.substr(17, 2);
    
    if (returnInt == true) {
        return parseInt(year + month + day + hour + minute + sec);
    }
    else {
        if (lang == "de") {
            return hour + ":" + minute + ":" + sec;
        }
        else {
            return hour + ":" + minute + ":" + sec;
        }
    }
    return null;
}


/*
 * send a query to facebook
 */
function send(path, params, method, callback){
    var query = params.join('&');
    var url = path + query;
    var xmlhttp = new XMLHttpRequest();
    xmlhttp.open(method, url, true);
    xmlhttp.onreadystatechange = function(){
        if (xmlhttp.readyState != 4) {
            //alert(xmlhttp.responseText);
        }
        if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
            callback(xmlhttp.responseText);
        }
    }
    xmlhttp.send(null);
}


/*
 * get style from an element
 */
function getStyle(oElm, strCssRule){
    var strValue = "";
    if (document.defaultView && document.defaultView.getComputedStyle) {
        strValue = document.defaultView.getComputedStyle(oElm, "").getPropertyValue(strCssRule);
    }
    else 
        if (oElm.currentStyle) {
            strCssRule = strCssRule.replace(/\-(\w)/g, function(strMatch, p1){
                return p1.toUpperCase();
            });
            strValue = oElm.currentStyle[strCssRule];
        }
    return strValue;
}



/*
 * icons, mouse clicked 
 */
function iconClicked(event){
  var btnUrl = "";
  switch(event.target.id){
    case "fb-button-firefox":
      btnUrl = "http://www.firefox.de";
    break;
    case "fb-button-amazon-go":
      searchAmazon();   
      return;  
    break;
    case "fb-button-amazon":
      btnUrl = "http://www.amazon.de/gp/redirect.html?ie=UTF8&location=http%3A%2F%2Fwww.amazon.de%2Fgp%2Fgc%3Fie%3DUTF8%26ref_%3Dtopnav_giftcert%23&site-redirect=de&tag=firefox-music-21&linkCode=ur2&camp=1638&creative=19454";
    break;
    case "fb-button-facebook":
      btnUrl = "http://www.facebook.de";
    break;
    case "fb-button-pauschalreise":
      btnUrl = "http://www.pauschalreise.de";
    break;
    case "fb-button-bummeln":
      btnUrl = "http://www.bummeln.de";
    break;
    case "fb-button-swisabeauty":
      btnUrl = "http://www.swisabeauty.de";
    break;
    case "fb-button-triathlon":
      btnUrl = "http://www.triathlon.de";
    break;
  }
  openTab(btnUrl);
}

/*
 * Enter pressed in Amazon search box?
 */
function fbKeyEventHandler(event){
  event = event || window.event;
  if(event.keyCode == 13){
    searchAmazon();
  }
}

function searchAmazon(){
  var query = document.getElementById("fb-textbox-amazon").value;
  openTab("http://www.amazon.de/s?ie=UTF8&tag=firefox-musik-21&index=blended&link_code=qs&field-keywords="+query+"&sourceid=Mozilla-search");
}



/*
 * Open a new tab
 */
function openTab(url){
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"] .getService(Components.interfaces.nsIWindowMediator);
  var mainWindow = wm.getMostRecentWindow("navigator:browser");
  mainWindow.gBrowser.selectedTab = mainWindow.gBrowser.addTab(url);
}















